#!/usr/bin/python2.4
#    Copyright 2009 Alex Joni
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# graphic model of a Unimate Puma 560
# according to the dimensions from: http://www.juve.ro/blog/puma/
# the obj files can be downloaded there, and may be included in emc2 later

# link description
# link1 - stationary base
# link2 .. link7 - the 6 moving parts of the robot, numbered form base to end effector

from vismach import *
import hal

c = hal.component("6husgui")
c.newpin("joint1", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint2", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint3", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint4", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint5", hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("joint6", hal.HAL_FLOAT, hal.HAL_IN)
c.ready()



# units are mm

#tool goes here.. maybe later


work = Capture()

extratool = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-1/KuangJia-1 WaiHuanJia-1.STL")
extratool = Color([0,1,0,0],[extratool])

tool = Capture()
tooltip = Capture()
tool = Collection([tooltip, tool])
extratool = Collection([extratool, tool])

# ######################---fixedplatform---######################

fixedplatform = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/fixedplatform.STL")

#green
fixedplatform = Color([0,1,0,0],[fixedplatform])
fixedplatform = Collection([fixedplatform])
# ######################---movingplatform---######################

movingplatform = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/movingplatform.STL")

#blue
movingplatform = Color([0,0,1,0],[movingplatform]) 

#movingplatform = Collection([movingplatform, tool])

# ######################---movingstick1---######################

stick11 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan1/gan1_lingjian - zhilian-1 Gan-1.STL")

stick12 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan1/gan1_lingjian - zhilian-1 ShiZiZhou-1.STL")

stick13 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan1/gan1_lingjian - zhilian-1 SiGangLuoMu-2.STL")

stick1 = Collection([stick11, stick12, stick13])
stick1 = Color([0.7,0,0,0],[stick1])

# ######################---movingstick2---######################

stick21 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan2/gan2 - zhilian-2 Gan-1.STL")

stick22 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan2/gan2 - zhilian-2 ShiZiZhou-1.STL")

stick23 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan2/gan2 - zhilian-2 SiGangLuoMu-2.STL")

stick2 = Collection([stick21, stick22, stick23])
stick2 = Color([0.7,0,0,0],[stick2])

# ######################---movingstick3---######################

stick31 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan3/gan3 - zhilian-3 Gan-1.STL")

stick32 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan3/gan3 - zhilian-3 ShiZiZhou-1.STL")

stick33 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan3/gan3 - zhilian-3 SiGangLuoMu-2.STL")

stick3 = Collection([stick31, stick32, stick33])
stick3 = Color([0.7,0,0,0],[stick3])

# ######################---movingstick4---######################

stick41 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan4/gan4 - zhilian-4 Gan-1.STL")

stick42 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan4/gan4 - zhilian-4 ShiZiZhou-1.STL")

stick43 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan4/gan4 - zhilian-4 SiGangLuoMu-2.STL")

stick4 = Collection([stick41, stick42, stick43])
stick4 = Color([0.7,0,0,0],[stick4])


# ######################---movingstick5---######################

stick51 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan5/gan5 - zhilian-5 Gan-1.STL")

stick52 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan5/gan5 - zhilian-5 ShiZiZhou-1.STL")

stick53 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan5/gan5 - zhilian-5 SiGangLuoMu-2.STL")

stick5 = Collection([stick51, stick52, stick53])
stick5 = Color([0.7,0,0,0],[stick5])

# ######################---movingstick6---######################

stick61 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan6/gan6 - zhilian-6 Gan-1.STL")

stick62 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan6/gan6 - zhilian-6 ShiZiZhou-1.STL")

stick63 = AsciiSTL(filename="/home/mgg/linuxcnc/configs/6HUS/6husgui/6hus-2/gan6/gan6 - zhilian-6 SiGangLuoMu-2.STL")

stick6 = Collection([stick61, stick62, stick63])
stick6 = Color([0.7,0,0,0],[stick6])

# stationary base
puma = Collection([extratool, stick1, stick2, stick3, stick4, stick5,stick6, movingplatform])

##puma = Collection([movingplatform])
##model = Collection([tooltip, puma, fixedplatform, work])
model = Collection([tooltip, puma, fixedplatform, work])

main(model, tooltip, work, 1000 )
